unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, SQLDB, SQLite3Conn, Forms, Controls, Graphics, Dialogs,
  DBGrids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  SQLQuery1.Locate('test', 200000, []);
end;

procedure TForm1.Button2Click(Sender: TObject);
var x,i:integer;
    s:string;
begin
 setLength(s,100);

 SQLQuery1.Active:=False;
 SQLQuery1.SQL.Clear;
 SQLQuery1.SQL.Add('delete from test');
 SQLQuery1.ExecSQL;
 SQLTransaction1.CommitRetaining;

 for x:=1 to 1000000 do
 begin
   SQLQuery1.SQL.Clear;
   SQLQuery1.SQL.Add('insert into test (test,test1,test2,test3,test4,test5) values');
   SQLQuery1.SQL.Add('(:VAL1,:VAL2,:VAL3,:VAL4,:VAL5,:VAL6)');

   SQLQuery1.ParamByName('VAL1').AsInteger:=x;

   for i := 1 to 100 do s[i] := chr(random (120-100)+100);
   SQLQuery1.ParamByName('VAL2').AsString:=s;

   for i := 1 to 100 do s[i] := chr(random (120-100)+100);
   SQLQuery1.ParamByName('VAL3').AsString:=s;

   for i := 1 to 100 do s[i] := chr(random (120-100)+100);
   SQLQuery1.ParamByName('VAL4').AsString:=s;

   for i := 1 to 100 do s[i] := chr(random (120-100)+100);
   SQLQuery1.ParamByName('VAL5').AsString:=s;

   for i := 1 to 100 do s[i] := chr(random (120-100)+100);
   SQLQuery1.ParamByName('VAL6').AsString:=s;

   SQLQuery1.ExecSQL;
 end;
 SQLTransaction1.CommitRetaining;

 SQLQuery1.Active:=False;
 SQLQuery1.SQL.Clear;
 SQLQuery1.SQL.Add('select * from test order by test desc');
 SQLQuery1.Active:=True;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
  SQLite3Connection1.DatabaseName:='db.s3db';
  SQLite3Connection1.Connected:=True;
  SQLQuery1.SQL.Add('select * from test order by test desc');
  SQLQuery1.Active:=True;


end;

end.

